public class ArrayMap implements Map { 
    protected String[] keys;
    protected String[] values;
    protected int n;
    public ArrayMap(int maxSize) {
        keys = new String[maxSize];
        values = new String[maxSize];
        n = 0;
    }
    public int size() {
        return n;
    }
    protected int findIndex(String key) {
        for (int i=0; i<n; i++) {
            if (keys[i].equals(key)) {
                return i;
            }
        }
        return n;
    }
    public String get(String key) {
        int i = findIndex(key);
        if (i == n) {
            return null;
        } else {
            return values[i];
        }
    }
    public boolean put(String key, String value) {
        int i = findIndex(key);
        if (i < keys.length) {
            keys[i] = key;
            values[i] = value;
        } else {
            return false;
        }
        if (i == n) {
            n++;
        }
        return true;
    }
    public boolean putAll(Map other) {
        Iterator i = other.keys();
        boolean res = true;
        while (i.hasNext()) {
            String key = i.next();
            res = put(key, other.get(key)) && res;
        }
        return res;
    }
    public String toString() {
        String res = "(";
        for (int i=0; i<n; i++) {
            if (i > 0) {
                res += ", ";
            }
            res += keys[i] + " -> " + values[i];
        }
        return res + ")";
    }
    public Iterator keys() {
        return new ArrayIterator(keys,n);
    }
}
